var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { reactSelectComponents } from './helpers';
import { mergeClasses } from '../../helpers/classes';
import { useStyles } from './styles';
var EMPTY_OBJECT = {};
export var withReactSelectMuiSkin = function (SelectComponent) {
    function WrappedSelectComponent(_a) {
        var _b = _a.components, componentsProp = _b === void 0 ? EMPTY_OBJECT : _b, _c = _a.classes, classesProp = _c === void 0 ? EMPTY_OBJECT : _c, error = _a.error, TextFieldProps = _a.TextFieldProps, innerRef = _a.innerRef, selectProps = __rest(_a, ["components", "classes", "error", "TextFieldProps", "innerRef"]);
        var skinClasses = useStyles();
        var components = __assign(__assign({}, reactSelectComponents), componentsProp);
        var classes = mergeClasses(skinClasses, classesProp);
        return (React.createElement(SelectComponent, __assign({ ref: innerRef, components: components, classes: classes, TextFieldProps: __assign(__assign({}, TextFieldProps), { error: error }) }, selectProps)));
    }
    WrappedSelectComponent.displayName = "withMuiSkin(".concat(SelectComponent.displayName || SelectComponent.name, ")");
    return WrappedSelectComponent;
};
